/* Pinout of the DEBUG extension:
   NO extension!!!
 */

#ifdef NAME
#undef NAME
#endif
#define NAME "DEBUG"

void debug_init()
{
	check_extension(NAME);

	/* Configure 8255's */
	/* B:   10010010
		port A: OUTPUT
		port B: OUTPUT
		port Cl: OUTPUT
		port Ch: OUTPUT
	   A:   10010001
		port A: OUTPUT
		port B: OUTPUT
		port Cl: OUTPUT
		port Ch: OUTPUT
	*/
	OUTPORT(B_8255_PROG, 0x80|PA_out|PB_out|PCl_out|PCh_out);
	OUTPORT(A_8255_PROG, 0x80|PA_out|PB_out|PCl_out|PCh_out);
}

void debug_no_flag()
{
	int i;

#ifndef IO48
	for(i = 0x01; i < 0x100; i <<= 1) {
		OUTPORT(BUFFER, i);
		printf("Data on pins 1..8 should be 0x%02X - Press RETURN\n", i);
		getchar();
	}
#endif
	for(i = 0x01; i < 0x100; i <<= 1) {
		OUTPORT(B_8255_PA, i);
		printf("Data on pins 9..16 should be 0x%02X - Press RETURN\n", i);
		getchar();
	}
	for(i = 0x01; i < 0x100; i <<= 1) {
		OUTPORT(B_8255_PB, i);
		printf("Data on pins 17..24 should be 0x%02X - Press RETURN\n", i);
		getchar();
	}
	for(i = 0x01; i < 0x100; i <<= 1) {
		OUTPORT(B_8255_PC, i);
		printf("Data on pins 25..32 should be 0x%02X - Press RETURN\n", i);
		getchar();
	}
	for(i = 0x01; i < 0x100; i <<= 1) {
		OUTPORT(A_8255_PA, i);
		printf("Data on pins 33..40 should be 0x%02X - Press RETURN\n", i);
		getchar();
	}
	for(i = 0x01; i < 0x100; i <<= 1) {
		OUTPORT(A_8255_PB, i);
		printf("Data on pins 41..48 should be 0x%02X - Press RETURN\n", i);
		getchar();
	}
	for(i = 0x01; i < 0x100; i <<= 1) {
		OUTPORT(A_8255_PC, i);
		printf("Data on pins 49..56 should be 0x%02X - Press RETURN\n", i);
		getchar();
	}
	printf("End of test\n");
}

void debug_usage()
{
	printf(
	"DEBUG extension:\n"
	"              The DEBUG extension is a simple cable with NO connections. All\n"
	"              lines of the ISA card are configured as output. Output signals\n"
	"              can be checked using a multimeter.\n");
}

Extension debug_ext = {
	NAME,
	debug_init,
	debug_no_flag,
	NULL,		/* analyze */
	NULL,		/* save */
	NULL,		/* backup */
	NULL,		/* restore */
	NULL,		/* clear */
	NULL,		/* test */
	NULL,		/* debug */
	NULL,		/* extra */
	debug_usage
};
